wxWidgets: wxTaskBarIcon Class Reference

| Version: 3.2.5

Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
wxTaskBarIcon Class Reference
Class List by Category » Miscellaneous

`#include <wx/taskbar.h>`

Inheritance diagram for wxTaskBarIcon:
[legend]

## Detailed Description

This class represents a taskbar icon.

A taskbar icon is an icon that appears in the 'system tray' and responds to mouse clicks, optionally with a tooltip above it to help provide information.

# X Window System Note

Under X Window System, the window manager must support either the "System Tray Protocol" (see http://freedesktop.org/wiki/Specifications/systemtray-spec) by freedesktop.org (WMs used by modern desktop environments such as GNOME >= 2, KDE >= 3 and XFCE >= 4 all do) or the older methods used in GNOME 1.2 and KDE 1 and 2.

If it doesn't, the icon will appear as a toplevel window on user's desktop. Because not all window managers have system tray, there's no guarantee that wxTaskBarIcon will work correctly under X Window System and so the applications should use it only as an optional component of their user interface. The user should be required to explicitly enable the taskbar icon on Unix, it shouldn't be on by default.

## Events emitted by this class

The following event handler macros redirect the events to member function handlers 'func' with prototypes like:

void handlerFuncName(wxTaskBarIconEvent& event)

Event macros for events emitted by this class:

Note that not all ports are required to send these events and so it's better to override wxTaskBarIcon::CreatePopupMenu() or wxTaskBarIcon::GetPopupMenu() if all that the application does is that it shows a popup menu in reaction to mouse click.

- EVT_TASKBAR_MOVE(func):
  Process a `wxEVT_TASKBAR_MOVE` event.
- EVT_TASKBAR_LEFT_DOWN(func):
  Process a `wxEVT_TASKBAR_LEFT_DOWN` event.
- EVT_TASKBAR_LEFT_UP(func):
  Process a `wxEVT_TASKBAR_LEFT_UP` event.
- EVT_TASKBAR_RIGHT_DOWN(func):
  Process a `wxEVT_TASKBAR_RIGHT_DOWN` event.
- EVT_TASKBAR_RIGHT_UP(func):
  Process a `wxEVT_TASKBAR_RIGHT_UP` event.
- EVT_TASKBAR_LEFT_DCLICK(func):
  Process a `wxEVT_TASKBAR_LEFT_DCLICK` event.
- EVT_TASKBAR_RIGHT_DCLICK(func):
  Process a `wxEVT_TASKBAR_RIGHT_DCLICK` event.
- EVT_TASKBAR_CLICK(func):
  This is a synonym for either EVT_TASKBAR_RIGHT_DOWN or UP depending on the platform, use this event macro to catch the event which should result in the menu being displayed on the current platform.

##

Library: wxCore
Category: Miscellaneous

## Public Member Functions
| wxTaskBarIcon (wxTaskBarIconType iconType=wxTBI_DEFAULT_TYPE)
| Default constructor. More...
virtual | ~wxTaskBarIcon ()
| Destroys the wxTaskBarIcon object, removing the icon if not already removed. More...
void | Destroy ()
| This method is similar to wxWindow::Destroy and can be used to schedule the task bar icon object for the delayed destruction: it will be deleted during the next event loop iteration, which allows the task bar icon to process any pending events for it before being destroyed. More...
bool | IsIconInstalled () const
| Returns true if SetIcon() was called with no subsequent RemoveIcon(). More...
bool | IsOk () const
| Returns true if the object initialized successfully. More...
virtual bool | PopupMenu (wxMenu *menu)
| Pops up a menu at the current mouse position. More...
virtual bool | RemoveIcon ()
| Removes the icon previously set with SetIcon(). More...
virtual bool | SetIcon (const wxBitmapBundle &icon, const wxString &tooltip=wxEmptyString)
| Sets the icon, and optional tooltip text. More...
Public Member Functions inherited from wxEvtHandler
| wxEvtHandler ()
| Constructor. More...
virtual | ~wxEvtHandler ()
| Destructor. More...
virtual void | QueueEvent (wxEvent *event)
| Queue event for a later processing. More...
virtual void | AddPendingEvent (const wxEvent &event)
| Post an event to be processed later. More...
template<typename T , typename T1 , ... >
void | CallAfter (void(T::*method)(T1,...), T1 x1,...)
| Asynchronously call the given method. More...
template<typename T >
void | CallAfter (const T &functor)
| Asynchronously call the given functor. More...
virtual bool | ProcessEvent (wxEvent &event)
| Processes an event, searching event tables and calling zero or more suitable event handler function(s). More...
bool | ProcessEventLocally (wxEvent &event)
| Try to process the event in this handler and all those chained to it. More...
bool | SafelyProcessEvent (wxEvent &event)
| Processes an event by calling ProcessEvent() and handles any exceptions that occur in the process. More...
void | ProcessPendingEvents ()
| Processes the pending events previously queued using QueueEvent() or AddPendingEvent(); you must call this function only if you are sure there are pending events for this handler, otherwise a `wxCHECK` will fail. More...
void | DeletePendingEvents ()
| Deletes all events queued on this event handler using QueueEvent() or AddPendingEvent(). More...
void | Connect (int id, int lastId, wxEventType eventType, wxObjectEventFunction function, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| Connects the given function dynamically with the event handler, id and event type. More...
void | Connect (int id, wxEventType eventType, wxObjectEventFunction function, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| See the Connect(int, int, wxEventType, wxObjectEventFunction, wxObject*, wxEvtHandler*) overload for more info. More...
void | Connect (wxEventType eventType, wxObjectEventFunction function, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| See the Connect(int, int, wxEventType, wxObjectEventFunction, wxObject*, wxEvtHandler*) overload for more info. More...
bool | Disconnect (wxEventType eventType, wxObjectEventFunction function, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| Disconnects the given function dynamically from the event handler, using the specified parameters as search criteria and returning true if a matching function has been found and removed. More...
bool | Disconnect (int id=wxID_ANY, wxEventType eventType=wxEVT_NULL, wxObjectEventFunction function=NULL, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| See the Disconnect(wxEventType, wxObjectEventFunction, wxObject*, wxEvtHandler*) overload for more info. More...
bool | Disconnect (int id, int lastId, wxEventType eventType, wxObjectEventFunction function=NULL, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| See the Disconnect(wxEventType, wxObjectEventFunction, wxObject*, wxEvtHandler*) overload for more info. More...
template<typename EventTag , typename Functor >
void | Bind (const EventTag &eventType, Functor functor, int id=wxID_ANY, int lastId=wxID_ANY, wxObject *userData=NULL)
| Binds the given function, functor or method dynamically with the event. More...
template<typename EventTag , typename Class , typename EventArg , typename EventHandler >
void | Bind (const EventTag &eventType, void(Class::*method)(EventArg &), EventHandler *handler, int id=wxID_ANY, int lastId=wxID_ANY, wxObject *userData=NULL)
| See the Bind<>(const EventTag&, Functor, int, int, wxObject*) overload for more info. More...
template<typename EventTag , typename Functor >
bool | Unbind (const EventTag &eventType, Functor functor, int id=wxID_ANY, int lastId=wxID_ANY, wxObject *userData=NULL)
| Unbinds the given function, functor or method dynamically from the event handler, using the specified parameters as search criteria and returning true if a matching function has been found and removed. More...
template<typename EventTag , typename Class , typename EventArg , typename EventHandler >
bool | Unbind (const EventTag &eventType, void(Class::*method)(EventArg &), EventHandler *handler, int id=wxID_ANY, int lastId=wxID_ANY, wxObject *userData=NULL)
| See the Unbind<>(const EventTag&, Functor, int, int, wxObject*) overload for more info. More...
void * | GetClientData () const
| Returns user-supplied client data. More...
wxClientData * | GetClientObject () const
| Returns a pointer to the user-supplied client data object. More...
void | SetClientData (void *data)
| Sets user-supplied client data. More...
void | SetClientObject (wxClientData *data)
| Set the client data object. More...
bool | GetEvtHandlerEnabled () const
| Returns true if the event handler is enabled, false otherwise. More...
wxEvtHandler * | GetNextHandler () const
| Returns the pointer to the next handler in the chain. More...
wxEvtHandler * | GetPreviousHandler () const
| Returns the pointer to the previous handler in the chain. More...
void | SetEvtHandlerEnabled (bool enabled)
| Enables or disables the event handler. More...
virtual void | SetNextHandler (wxEvtHandler *handler)
| Sets the pointer to the next handler. More...
virtual void | SetPreviousHandler (wxEvtHandler *handler)
| Sets the pointer to the previous handler. More...
void | Unlink ()
| Unlinks this event handler from the chain it's part of (if any); then links the "previous" event handler to the "next" one (so that the chain won't be interrupted). More...
bool | IsUnlinked () const
| Returns true if the next and the previous handler pointers of this event handler instance are NULL. More...
Public Member Functions inherited from wxObject
| wxObject ()
| Default ctor; initializes to NULL the internal reference data. More...
| wxObject (const wxObject &other)
| Copy ctor. More...
virtual | ~wxObject ()
| Destructor. More...
virtual wxClassInfo * | GetClassInfo () const
| This virtual function is redefined for every class that requires run-time type information, when using the wxDECLARE_CLASS macro (or similar). More...
wxObjectRefData * | GetRefData () const
| Returns the wxObject::m_refData pointer, i.e. the data referenced by this object. More...
bool | IsKindOf (const wxClassInfo *info) const
| Determines whether this class is a subclass of (or the same class as) the given class. More...
bool | IsSameAs (const wxObject &obj) const
| Returns true if this object has the same data pointer as obj. More...
void | Ref (const wxObject &clone)
| Makes this object refer to the data in clone. More...
void | SetRefData (wxObjectRefData *data)
| Sets the wxObject::m_refData pointer. More...
void | UnRef ()
| Decrements the reference count in the associated data, and if it is zero, deletes the data. More...
void | UnShare ()
| This is the same of AllocExclusive() but this method is public. More...
void | operator delete (void *buf)
| The delete operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined. More...
void * | operator new (size_t size, const wxString &filename=NULL, int lineNum=0)
| The new operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined. More...

## Static Public Member Functions
static bool | IsAvailable ()
| Returns true if system tray is available in the desktop environment the app runs under. More...
Static Public Member Functions inherited from wxEvtHandler
static void | AddFilter (wxEventFilter *filter)
| Add an event filter whose FilterEvent() method will be called for each and every event processed by wxWidgets. More...
static void | RemoveFilter (wxEventFilter *filter)
| Remove a filter previously installed with AddFilter(). More...

## Protected Member Functions
virtual wxMenu * | CreatePopupMenu ()
| Called by the library when the user requests popup menu if GetPopupMenu() is not overridden. More...
virtual wxMenu * | GetPopupMenu ()
| Called by the library when the user requests popup menu. More...
Protected Member Functions inherited from wxEvtHandler
virtual bool | TryBefore (wxEvent &event)
| Method called by ProcessEvent() before examining this object event tables. More...
virtual bool | TryAfter (wxEvent &event)
| Method called by ProcessEvent() as last resort. More...
Protected Member Functions inherited from wxObject
void | AllocExclusive ()
| Ensure that this object's data is not shared with any other object. More...
virtual wxObjectRefData * | CreateRefData () const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and returns it. More...
virtual wxObjectRefData * | CloneRefData (const wxObjectRefData *data) const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and initializes it copying data. More...

## Additional Inherited Members
Protected Attributes inherited from wxObject
wxObjectRefData * | m_refData
| Pointer to an object which is the object's reference-counted data. More...

## Constructor & Destructor Documentation

## ◆ wxTaskBarIcon()

wxTaskBarIcon::wxTaskBarIcon | ( | wxTaskBarIconType | iconType = `wxTBI_DEFAULT_TYPE` | ) |

Default constructor.

The iconType is only applicable on wxOSX/Cocoa.

## ◆ ~wxTaskBarIcon()

virtual wxTaskBarIcon::~wxTaskBarIcon | ( |  | ) |
| virtual

Destroys the wxTaskBarIcon object, removing the icon if not already removed.

## Member Function Documentation

## ◆ CreatePopupMenu()

virtual wxMenu* wxTaskBarIcon::CreatePopupMenu | ( |  | ) |
| protectedvirtual

Called by the library when the user requests popup menu if GetPopupMenu() is not overridden.

Override this function in order to provide popup menu associated with the icon if you don't want to override GetPopupMenu(), i.e. if you prefer creating a new menu every time instead of reusing the same menu.

If CreatePopupMenu() returns NULL (this happens by default), no menu is shown, otherwise the menu is displayed and then deleted by the library as soon as the user dismisses it. If you don't want the menu to be destroyed when it is dismissed, override GetPopupMenu() instead.

## ◆ Destroy()

void wxTaskBarIcon::Destroy | ( |  | ) |

This method is similar to wxWindow::Destroy and can be used to schedule the task bar icon object for the delayed destruction: it will be deleted during the next event loop iteration, which allows the task bar icon to process any pending events for it before being destroyed.

## ◆ GetPopupMenu()

virtual wxMenu* wxTaskBarIcon::GetPopupMenu | ( |  | ) |
| protectedvirtual

Called by the library when the user requests popup menu.

On Windows and Unix platforms this happens when the user right-clicks the icon, so overriding this method is the simplest way to implement the standard behaviour of showing a menu when the taskbar icon is clicked.

If GetPopupMenu() returns NULL (this happens by default), CreatePopupMenu() is called next and its menu is used (if non-NULL). Otherwise the menu returned by GetPopupMenu() is shown and, contrary to CreatePopupMenu(), not destroyed when the user dismisses it, allowing to reuse the same menu pointer multiple times.

Since
  3.1.5

## ◆ IsAvailable()

static bool wxTaskBarIcon::IsAvailable | ( |  | ) |
| static

Returns true if system tray is available in the desktop environment the app runs under.

On Windows and macOS, the tray is always available and this function simply returns true.

On Unix, X11 environment may or may not provide the tray, depending on user's desktop environment. Most modern desktops support the tray via the System Tray Protocol by freedesktop.org (http://freedesktop.org/wiki/Specifications/systemtray-spec).

Note
  Tray availability may change during application's lifetime under X11 and so applications shouldn't cache the result.
  wxTaskBarIcon supports older GNOME 1.2 and KDE 1/2 methods of adding icons to tray, but they are unreliable and this method doesn't detect them.

Since
  2.9.0

## ◆ IsIconInstalled()

bool wxTaskBarIcon::IsIconInstalled | ( |  | ) | const

Returns true if SetIcon() was called with no subsequent RemoveIcon().

## ◆ IsOk()

bool wxTaskBarIcon::IsOk | ( |  | ) | const

Returns true if the object initialized successfully.

## ◆ PopupMenu()

virtual bool wxTaskBarIcon::PopupMenu | ( | wxMenu * | menu | ) |
| virtual

Pops up a menu at the current mouse position.

The events can be handled by a class derived from wxTaskBarIcon.

Note
  It is recommended to override the CreatePopupMenu() or GetPopupMenu() callback instead of calling this method from event handler, because some ports (e.g. wxCocoa) may not implement PopupMenu() and mouse click events at all.

## ◆ RemoveIcon()

virtual bool wxTaskBarIcon::RemoveIcon | ( |  | ) |
| virtual

Removes the icon previously set with SetIcon().

## ◆ SetIcon()

virtual bool wxTaskBarIcon::SetIcon | ( | const wxBitmapBundle & | icon,
|  | const wxString & | tooltip = `wxEmptyString`
| ) |  |
| virtual

Sets the icon, and optional tooltip text.